.common.oci.builder:
  # Common job definition. This contains the tools necessary for managing nested containers.
  # Builder image is pulled during the before_script
  image: docker:stable
  services:
    - docker:dind
  tags:
    - k8srunner
  variables:
    OCI_BUILDER: registry.gitlab.com/ska-telescope/pst/ska-pst-buildtools/ska-pst-buildtools:0.0.2

pull_image:
  extends: .common.oci.builder
  stage: build
  script:
    - mkdir -p build_artefacts
    # - make oci-builder-pull OCI_BUILDER=$OCI_BUILDER
    - docker pull $OCI_BUILDER

build_debug:
  # Containerised build job responsible for generating debug build artefacts
  extends: .common.oci.builder
  needs:
    - pull_image
  stage: build
  before_script:
    - ls -l .pst/cpp.mk
    - docker inspect $OCI_BUILDER
  script:
    - mkdir -p build
    - docker run --rm -v $CI_PROJECT_DIR:/mnt/$CI_PROJECT_NAME -w /mnt/$CI_PROJECT_NAME $OCI_BUILDER bash -c "pwd && ls -laR /mnt/$CI_PROJECT_NAME"
    - docker run --rm -v $CI_PROJECT_DIR:/mnt/$CI_PROJECT_NAME -w /mnt/$CI_PROJECT_NAME $OCI_BUILDER bash -c "make local-cpp-build-debug"
    - ls -laR ./build

build_release:
  # Containerised build job responsible for generating release build artefacts
  extends: .common.oci.builder
  needs:
    - pull_image
  stage: build
  before_script:
    - ls -l .pst/cpp.mk
    - docker inspect $OCI_BUILDER
  script:
    - mkdir -p build
    - docker run --rm -v $CI_PROJECT_DIR:/mnt/$CI_PROJECT_NAME -w /mnt/$CI_PROJECT_NAME $OCI_BUILDER bash -c "make local-cpp-build-release"
    - ls -laR ./build

build_export_compile_commands:
  extends: .common.oci.builder
  needs:
    - pull_image
  stage: build
  before_script:
    - ls -l .pst/cpp.mk
    - docker inspect $OCI_BUILDER
  script:
    - mkdir -p build
    - docker run --rm -v $CI_PROJECT_DIR:/mnt/$CI_PROJECT_NAME -w /mnt/$CI_PROJECT_NAME $OCI_BUILDER bash -c "make local-cpp-build-export-compile-commands"
    - ls -laR ./build